<template>
  <div class="model container">
    <div v-if="isError" class="error">
      <h1 class="title is-1">Error</h1>
      <h2 class="subtitle">Cant find model</h2>
    </div>
    <div v-else-if="model">
      <div class="columns box">
        <div class="column is-two-thirds">
          <h1 class="title is-1">{{model.name}} <b-tag v-if="model.isVerified" type="is-success" size="is-large">Verified</b-tag></h1>
          <h2 class="subtitle">{{model.shortDescription}}</h2>
          <b-taglist>
            <b-tag v-for="tag in model.tags" v-bind:key="tag.name" type="is-info">{{tag.name}}</b-tag>
          </b-taglist>
          <hr>
          <div class="content">
            <blockquote>mozen_zoo.load("{{model.id}}", "r")</blockquote>
          </div>
        </div>
        <div class="column infoColumn">
          <div v-if="isAuthor">
            <b-button icon-left="pencil" type="is-warning" tag="router-link" :to="{ name: 'ModelEdit', params: {model: model} }">Edit model</b-button>
            <br>
            <br>
          </div>
          <Vote v-bind:modelId="model.id" v-bind:voteCount="model.votes"/>
          <small>Author: </small><strong>{{model.author.username}}</strong>
          <br>
          <small>Added: </small><strong>{{new Date(model.added).toLocaleDateString()}}</strong>
          <br>
          <small>Last modification: </small><strong>{{new Date(model.lastModified).toLocaleDateString()}}</strong>
          <br>
          <small>parameters: </small><strong>{{model.parameterCount}}</strong>
          <br>
          <small>{{model.performanceUnit}}: </small><strong>{{model.performance}}</strong>
          <br>
          <br>
          <div v-if="model.checksum">
            <b-button v-if="model.checksum" type="is-primary" size="is-medium" icon-left="download" @click="download(model.id, 'models', model.fileName)">
              Download model
            </b-button>
            <br>
            <br>
            <small>Checksum: {{model.checksum}}</small>
          </div>
          <h2 v-else class="title is-5">No file provided</h2>
          <hr>
          <strong>{{model.customLayers.length}} customs layers</strong>
          <br>
          <template v-for="layer in model.customLayers">
            <b-button class="customLayer" type="is-primary" icon-left="download" v-bind:key="layer.name" @click="download(layer.id, 'layers', layer.fileName)">
            Download {{layer.name}}
            </b-button>
          </template>
        </div>
      </div>
      <div class="box">
        <b-tabs>
          <b-tab-item label="Read me">
            <div class="content" v-html="compiledLongDescription"></div>
          </b-tab-item>

          <b-tab-item label="Layers">
          </b-tab-item>

          <b-tab-item label="Comments">
            <div class="box">
              <Comments v-if="!isLoading" v-bind:modelId="model.id"/>
            </div>
          </b-tab-item>
        </b-tabs>
      </div>
    </div>
    <b-loading :is-full-page="false" :active.sync="isLoading"/>
  </div>
</template>

<script>
import Comments from '@/components/Comments.vue'
import Vote from '@/components/Vote.vue'
import marked from 'marked'
import { api } from '@/api.js'

export default {
  name: 'Model',
  components: {
    Comments,
    Vote
  },
  data () {
    return {
      model: null,
      isError: false,
      isLoading: true,
      isAuthor: false,
      downloadUrl: null
    }
  },
  computed: {
    compiledLongDescription: function () {
      return marked(this.model.longDescription)
    }
  },
  async mounted () {
    const id = this.$route.query.id
    this.model = await api.getModel(id)
    if (this.model == null) this.isError = true
    this.isLoading = false

    const userId = await localStorage.getItem('user_id')
    if (parseInt(userId) === this.model.author.id) this.isAuthor = true

    const userRole = await localStorage.getItem('user_role')
    if (userRole === 'ADMIN') this.isAuthor = true

    this.downloadUrl = this.$serverurl + 'models/download?id=' + this.model.id
  },
  methods: {
    async download (id, type, name) {
      this.$buefy.toast.open('Downloading ' + name)
      api.download(id, type, name)
    }
  }
}
</script>

<style scoped>
.model {
  padding: 25px;
}
.error {
  margin-top: 50px;
  text-align: center;
}
.customLayer {
  margin-top: 8px;
}
.infoColumn {
  border-left: 2px solid whitesmoke;
}
</style>
